/************************************************************************
 * Palm lab,
 * Department of Computer Science,
 * Sun Yat-sen University, Guangzhou, China
 * http://www.zsusoft.com/~hankz
 *
 * Copyright 2013, Hankz Hankui Zhuo and Lintao Chen
 *
 *
 * This file is part of HTNML.
 *
 * HTNML is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * HTNML is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HTNML.  If not, see <http://www.gnu.org/licenses/>.
 *
 ************************************************************************/


#ifndef _IOMAN_
#define _IOMAN_

#include <stdio.h>

#include "Datastruct.h"
#include "Transformation.h"
#include "Maxsatz.h"

extern FILE *Solutionin;
extern FILE *Taskin;
extern int Solutionparse();
extern int Taskparse();

extern my_type var_best_value[tab_variable_size];

extern float partObsPercent;
extern float partDtrPercent;

extern int WSC;
extern int WAC;
extern int WT;

extern MethodNameList *methodNameList;

void loadInputFile(FILE **file, char *filename);

void readProfile(char path[], int &num, char maxsatName[], char maxsatName1[], char resName[]);

void outputMaxsat(Formula *formula, char *filename);

void outputReference(char *filename);

void outputResult(char *filename);

void outputType(FILE *file);

void outputPredicate(FILE *file);

void outputMethodList(FILE *file);

void printMethodName(FILE *file, char* name);

void outputActionList(FILE *file);

void printFormalStateList(FILE *file, FormalStateList *list, bool isPositive) ;

#endif
