/************************************************************************
 * Palm lab,
 * Department of Computer Science,
 * Sun Yat-sen University, Guangzhou, China
 * http://www.zsusoft.com/~hankz
 *
 * Copyright 2013, Hankz Hankui Zhuo and Lintao Chen
 *
 *
 * This file is part of HTNML.
 *
 * HTNML is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * HTNML is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HTNML.  If not, see <http://www.gnu.org/licenses/>.
 *
 ************************************************************************/



#include "IOMan.h"
#include "Maxsatz.h"
#include "Constrain.h"
#include "Transformation.h"
#include "Tool.h"
#include "MemMan.h"

ObjectList *objectList = NULL;        
PredicateList *formalPredList = NULL;
PredicateList *actualPredList = NULL;
PredicateList *actionSchemaList = NULL;
MethodStructList *methodStructList = NULL;
PredicateTable *goals = NULL;
ActionTable *totalLeafs = NULL;
TaskList *superRoots = NULL;
MethodNameList *methodNameList = NULL;
bool isFirstObservation = true;
ActionPredList *whiteList = NULL;
ActionPredList *blackList = NULL;
ActionModelList *actionModelList = NULL;
MethodModelList *methodModelList = NULL;

Formula *formula1 = newFormula();
Formula *formula2 = newFormula();

char *postfix = NULL;
int postfixLen = 0;
float partObsPercent = 0.0;
float partDtrPercent = 0.0;
int cutPoint = 0;
int WSC = 1;
int WAC = 1;
int WT = 1;


int main(int argc, char *argv[])
{
	srand((unsigned int) time(NULL));
	char path[MAX_LENGTH];
	int num;
	char maxsatName[MAX_LENGTH];
	char maxsatName1[MAX_LENGTH];
	char resName[MAX_LENGTH];
	
	readProfile(path, num, maxsatName, maxsatName1, resName);
	cutPoint = int (partDtrPercent * RAND_NUM);
	
	for(int i = 1; i <= num; ++i) {		
		char solnName[MAX_LENGTH];
		buildPath(solnName, path, "/Soln");
		postfix = intToString(i);
		postfixLen = strlen(postfix);
		strcat(solnName, postfix);
		isFirstObservation = true;
	
		if(totalLeafs == NULL) {
			totalLeafs = newActionTable();
			totalLeafs->head = newActionList();
			totalLeafs->tail = totalLeafs->head;
		
			superRoots = newTaskList();
			superRoots->head = newTask();
			superRoots->tail = superRoots->head;
		} else {
			totalLeafs->tail->next = newActionList();
			totalLeafs->tail = totalLeafs->tail->next;
			
			superRoots->tail->next = newTask();
			superRoots->tail = superRoots->tail->next;
		}
		loadInputFile(&Solutionin, solnName);
	}
	
	buildWhiteList();
	buildBlackList();
	
	buildWSC();
	buildWPC();
	buildWAC(formula1);
	outputMaxsat(formula1, maxsatName);
	maxSatz(maxsatName);
	buildSecondClauseList();
	buildWAC(formula2);
	outputMaxsat(formula2, maxsatName1);
	maxSatz(maxsatName1);
	buildActionModelList();
	buildMethodModelList();
	outputResult(resName);
	return 0;
}
