/************************************************************************
 * Palm lab,
 * Department of Computer Science,
 * Sun Yat-sen University, Guangzhou, China
 * http://www.zsusoft.com/~hankz
 *
 * Copyright 2013, Hankz Hankui Zhuo and Lintao Chen
 *
 *
 * This file is part of HTNML.
 *
 * HTNML is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * HTNML is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HTNML.  If not, see <http://www.gnu.org/licenses/>.
 *
 ************************************************************************/



#include "MemMan.h"

int* newInt(int len)
{
	int *ans = (int *) calloc(len, sizeof(int));
	CHECK_MEM(ans);
	return ans;
}

char* newStr(int len)
{
	char *ans = (char *) calloc(len, sizeof(char));
	CHECK_MEM(ans);
	return ans;
}

Variable* newVariable()
{
	Variable *ans = (Variable *) calloc(1, sizeof(Variable));
	CHECK_MEM(ans);
	return ans;
}

VariableList* newVariableList()
{
	VariableList *ans = (VariableList *) calloc(1, sizeof(VariableList));
	CHECK_MEM(ans);
	return ans;
}

VariableTable* newVariableTable()
{
	VariableTable *ans = (VariableTable *) calloc(1, sizeof(VariableTable));
	CHECK_MEM(ans);
	return ans;
}

VarArray* newVarArray()
{
	VarArray *ans = (VarArray *) calloc(1, sizeof(VarArray));
	CHECK_MEM(ans);
	return ans;
}
Integer* newInteger()
{
	Integer *ans = (Integer *) calloc(1, sizeof(Integer));
	CHECK_MEM(ans);
	return ans;
}

Object* newObject()
{
	Object *ans = (Object *) calloc(1, sizeof(Object));
	CHECK_MEM(ans);
	return ans;
}

ObjectList* newObjectList()
{
	ObjectList *ans = (ObjectList *) calloc(1, sizeof(ObjectList));
	CHECK_MEM(ans);
	return ans;
}

Predicate* newPredicate()
{
	Predicate *ans = (Predicate *) calloc(1, sizeof(Predicate));
	CHECK_MEM(ans);
	return ans;
}

PredicateList *newPredicateList()
{
	PredicateList *ans = (PredicateList *) calloc(1, sizeof(PredicateList));
	CHECK_MEM(ans);
	return ans;
}

PredicateTable *newPredicateTable()
{
	PredicateTable *ans = (PredicateTable *) calloc(1, sizeof(PredicateTable));
	CHECK_MEM(ans);
	return ans;
}

TaskStruct* newTaskStruct()
{
	TaskStruct *ans = (TaskStruct *) calloc(1, sizeof(TaskStruct));
	CHECK_MEM(ans);
	return ans;
}

TaskStructList* newTaskStructList()
{
	TaskStructList *ans = (TaskStructList *) calloc(1, sizeof(TaskStructList));
	CHECK_MEM(ans);
	return ans;
}

MethodStruct* newMethodStruct()
{
	MethodStruct *ans = (MethodStruct *) calloc(1, sizeof(MethodStruct));
	CHECK_MEM(ans);
	return ans;
}

MethodStructList* newMethodStructList()
{
	MethodStructList *ans = (MethodStructList *) calloc(1, sizeof(MethodStructList));
	CHECK_MEM(ans);
	return ans;
}

Task* newTask() {
	Task *ans = (Task *) calloc(1, sizeof(Task));
	CHECK_MEM(ans);
	return ans;
}

TaskList* newTaskList() {
	TaskList *ans = (TaskList *) calloc(1, sizeof(TaskList));
	CHECK_MEM(ans);
	return ans;
}

Action* newAction()
{
	Action *ans = (Action *) calloc(1, sizeof(Action));
	CHECK_MEM(ans);
	return ans;
}
ActionList* newActionList()
{
	ActionList *ans = (ActionList *) calloc(1, sizeof(ActionList));
	CHECK_MEM(ans);
	return ans;
}

ActionTable* newActionTable()
{
	ActionTable *ans = (ActionTable *) calloc(1, sizeof(ActionTable));
	CHECK_MEM(ans);
	return ans;
}

Wrap* newWrap()
{
	Wrap *ans = (Wrap *) calloc(1, sizeof(Wrap));
	CHECK_MEM(ans);
	return ans;
}

Node* newNode()
{
	Node *ans = (Node *) calloc(1, sizeof(Node));
	CHECK_MEM(ans);
	return ans;
}

NodeList* newNodeList()
{
	NodeList *ans = (NodeList *) calloc(1, sizeof(NodeList));
	CHECK_MEM(ans);
	return ans;
}

Atom* newAtom()
{
	Atom *ans = (Atom *) calloc(1, sizeof(Atom));
	CHECK_MEM(ans);
	return ans;
}

AtomList* newAtomList()
{
	AtomList *ans = (AtomList *) calloc(1, sizeof(AtomList));
	CHECK_MEM(ans);
	return ans;
}

Literal* newLiteral()
{
	Literal *ans = (Literal *) calloc(1, sizeof(Literal));
	CHECK_MEM(ans);
	return ans;
}

LiteralList* newLiteralList()
{
	LiteralList *ans = (LiteralList *) calloc(1, sizeof(LiteralList));
	CHECK_MEM(ans);
	return ans;
}

LiteralTable* newLiteralTable()
{
	LiteralTable *ans = (LiteralTable *) calloc(1, sizeof(LiteralTable));
	CHECK_MEM(ans);
	return ans;
}

Clause *newClause()
{
	Clause *ans = (Clause *) calloc(1, sizeof(Clause));
	CHECK_MEM(ans);
	return ans;
}

ClauseList *newClauseList()
{
	ClauseList *ans = (ClauseList *) calloc(1, sizeof(ClauseList));
	CHECK_MEM(ans);
	return ans;
}

MethodName* newMethodName()
{
	MethodName *ans = (MethodName *) calloc(1, sizeof(MethodName));
	CHECK_MEM(ans);
	return ans;
}

MethodNameList* newMethodNameList()
{
	MethodNameList *ans = (MethodNameList *) calloc(1, sizeof(MethodNameList));
	CHECK_MEM(ans);
	return ans;
}

FormalState* newFormalState()
{
	FormalState *ans = (FormalState *) calloc(1, sizeof(FormalState));
	CHECK_MEM(ans);
	return ans;
}
FormalStateList* newFormalStateList()
{
	FormalStateList *ans = (FormalStateList *) calloc(1, sizeof(FormalStateList));
	CHECK_MEM(ans);
	return ans;
}

ActionPred* newActionPred()
{
	ActionPred *ans = (ActionPred *) calloc(1, sizeof(ActionPred));
	CHECK_MEM(ans);
	return ans;
}

ActionPredList* newActionPredList()
{
	ActionPredList *ans = (ActionPredList *) calloc(1, sizeof(ActionPredList));
	CHECK_MEM(ans);
	return ans;
}

LeafPointer* newLeafPointer()
{
	LeafPointer *ans = (LeafPointer *) calloc(1, sizeof(LeafPointer));
	CHECK_MEM(ans);
	return ans;
}

ActionModel* newActionModel()
{
	ActionModel *ans = (ActionModel *) calloc(1, sizeof(ActionModel));
	CHECK_MEM(ans);
	return ans;
}

ActionModelList* newActionModelList()
{
	ActionModelList *ans = (ActionModelList *) calloc(1, sizeof(ActionModelList));
	CHECK_MEM(ans);
	return ans;
}

MethodModel* newMethodModel()
{
	MethodModel *ans = (MethodModel *) calloc(1, sizeof(MethodModel));
	CHECK_MEM(ans);
	return ans;
}

MethodModelList* newMethodModelList()
{
	MethodModelList *ans = (MethodModelList *) calloc(1, sizeof(MethodModelList));
	CHECK_MEM(ans);
	return ans;
}

Formula* newFormula()
{
	Formula *ans = (Formula *) calloc(1, sizeof(Formula));
	CHECK_MEM(ans);
	return ans;
}

tMethod* newtMethod()
{
	tMethod *ans = (tMethod *) calloc(1, sizeof(tMethod));
	CHECK_MEM(ans);
	return ans;
}

tMethodList* newtMethodList()
{
	tMethodList *ans = (tMethodList *) calloc(1, sizeof(tMethodList));
	CHECK_MEM(ans);
	return ans;
}

tAction* newtAction()
{
	tAction *ans = (tAction *) calloc(1, sizeof(tAction));
	CHECK_MEM(ans);
	return ans;
}

tActionList* newtActionList()
{	
	tActionList *ans = (tActionList *) calloc(1, sizeof(tActionList));
	CHECK_MEM(ans);
	return ans;
}

tVariableList* newtVariableList()
{
	tVariableList *ans = (tVariableList *) calloc(1, sizeof(tVariableList));
	CHECK_MEM(ans);
	return ans;
}

tVariableTable* newtVariableTable()
{
	tVariableTable *ans = (tVariableTable *) calloc(1, sizeof(tVariableTable));
	CHECK_MEM(ans);
	return ans;	
}

void freePredicate(Predicate *pred)
{
	if(pred == NULL) return;
	free(pred->name);
	freeVariableList(pred->paras);
	free(pred);
	pred = NULL;
}

void freeVariableList(VariableList *list)
{
	if(list == NULL) return;
	Variable *ptr = list->head;
	while(ptr) {
		Variable *tmp = ptr->next;
		freeVariable(ptr);
		ptr = tmp;
	}
	free(list);
	list = NULL;
}

void freeVariable(Variable *var)
{
	if(var == NULL) return;
	free(var->var);
	free(var);
	var = NULL;
}

void freeTaskStruct(TaskStruct *tStruct)
{
	if(tStruct == NULL) return;
	free(tStruct->name);
	free(tStruct);	 
	tStruct = NULL;
}

void freeTaskStructList(TaskStructList *list) 
{
	if(list == NULL) return;
	TaskStruct *p = list->head;
	while( p != NULL) {
		TaskStruct *tmp = p->next;
		freeTaskStruct(p);
		p = tmp;
	}
	list = NULL;
}

void freeMethodStruct(MethodStruct *mStruct)
{
	if(mStruct == NULL) return;
	freePredicate(mStruct->method);
	freeTaskStruct(mStruct->task);
	freeTaskStructList(mStruct->subTasks);
	free(mStruct);
	mStruct = NULL;
}

void freeInteger(Integer *integer)
{
	if(integer == NULL) return;
	free(integer->integers);
	free(integer);
	integer = NULL;
}

void freeAtom(Atom *atom)
{
	if(atom == NULL) return;
	freeInteger(atom->args);
	free(atom);
	atom = NULL;
}

void freeClause(Clause *clause)
{
	if(clause == NULL) return;
	freeLiteralList(clause->literalList);	
	free(clause);
	clause = NULL;
}

void freeLiteralList(LiteralList *list)
{
	if(list == NULL) return;
	Literal *p = list->head;
	while(p != NULL) {
		Literal *tmp = p->next;
		freeLiteral(p);
		p = tmp;
	}
	free(list);
	list = NULL;
}

void freeLiteral(Literal *literal)
{
	if(literal == NULL) return;
	freeAtom(literal->atom);
	free(literal);	
	literal = NULL;
}

void freeObjectList(ObjectList *list)
{
	if(list == NULL) return;
	Object *p = list->head;
	while(p != NULL) {
		Object *tmp = p->next;
		freeObject(p);
		p = tmp;
	}
	free(list);
	list = NULL;
}

void freeObject(Object *obj)
{
	if(obj == NULL) return;
	free(obj->name);
	free(obj->type);
	free(obj);
	obj = NULL;
}
