%{
#include <stdio.h>
#include <ctype.h>
#include "Result.tab.h"

void ResultToUpCase( char *from);
char *ResultPointerShift(char *s);

%}

a [Aa]
b [Bb]
c [Cc]
d [Dd]
e [Ee]
f [Ff]
g [Gg]
h [Hh]
i [Ii]
j [Jj]
k [Kk]
l [Ll]
m [Mm]
n [Nn]
o [Oo]
p [Pp]
q [Qq]
r [Rr]
s [Ss]
t [Tt]
u [Uu]
v [Vv]
w [Ww]
x [Xx]
y [Yy]
z [Zz]

%%

"("  { return(OPEN_PAREN); }

")"  {  return(CLOSE_PAREN); }

{t}{a}{s}{k}{s}	{ return(ResultS_TOK); }
":"{t}{a}{s}{k}  {  return(Result_TOK); }
":"{p}{a}{r}{a}{m}{e}{t}{e}{r}{s}	{ return(PARA_TOK); }
":"{p}{r}{e}{c}{o}{n}{d}{i}{t}{i}{o}{n}	{ return(PRECOND_TOK); }
":"{e}{f}{f}{e}{c}{t}	{ return(EFFECT_TOK); } 

[ \t\n\r]	;

[a-zA-Z][a-zA-Z0-9\-_\[\]]* {ResultToUpCase( yytext );
 strcpy(Resultlval.str, yytext); return(VARIABLE); }
 
"?"[a-zA-Z][a-zA-Z0-9\-_\[\]]* {ResultToUpCase( yytext );
 strcpy(Resultlval.str, yytext); return(VAR); }

"-"[ \t]*[a-zA-Z][a-zA-Z0-9\-_\[\]]*  {ResultToUpCase(yytext); 
 strcpy(Resultlval.str, ResultPointerShift(yytext)); return(TYPE); }

.	return yytext[0];

%%

int Resultwrap()
{
	return 1;
}

void ResultToUpCase( char *from)
{
  char tmp;
  tmp = *from;
  while('\0' != tmp) {
    *from = (char) toupper((int) tmp);
    tmp = *++from;
    }
}

char *ResultPointerShift(char *s)
{
  s++;
  for( ; (*s == ' ') || (*s == '\t'); s++ );
  return s;
}
