%{
#include <stdio.h>
#include <ctype.h>
#include "Solution.tab.h"

void solnToUpCase( char *from);
char *solnPointerShift(char *s);

%}

a [Aa]
b [Bb]
c [Cc]
d [Dd]
e [Ee]
f [Ff]
g [Gg]
h [Hh]
i [Ii]
j [Jj]
k [Kk]
l [Ll]
m [Mm]
n [Nn]
o [Oo]
p [Pp]
q [Qq]
r [Rr]
s [Ss]
t [Tt]
u [Uu]
v [Vv]
w [Ww]
x [Xx]
y [Yy]
z [Zz]

%%

"("  { return(OPEN_PAREN); }
")"  {  return(CLOSE_PAREN); }
"{"	{ return(OPEN); }
"}"	{ return(CLOSE); }

{s}{o}{l}{u}{t}{i}{o}{n}	{ return(SOLN_TOK); }
":"{o}{b}{j}{e}{c}{t}{s}  {  return(OBJECT_TOK); }
":"{i}{n}{i}{t}  {  return(INIT_TOK); }
":"{o}{b}{s}{e}{r}{v}{a}{t}{i}{o}{n}{s}	{  return(OBSERVATION_TOK); }
":"{g}{o}{a}{l}  {  return(GOAL_TOK); }

[ \t\n\r]	;

[a-zA-Z][a-zA-Z0-9\-_\[\]]* {solnToUpCase( yytext );
 strcpy(Solutionlval.str, yytext); return(VARIABLE); }
 
"-"[ \t]*[a-zA-Z][a-zA-Z0-9\-_\[\]]*  {solnToUpCase(yytext); 
 strcpy(Solutionlval.str, solnPointerShift(yytext)); return(TYPE); }

.	return yytext[0];

%%

int Solutionwrap()
{
	return 1;
}

void solnToUpCase( char *from)
{
  char tmp;
  tmp = *from;
  while('\0' != tmp) {
    *from = (char) toupper((int) tmp);
    tmp = *++from;
    }
}

char *solnPointerShift(char *s)
{
  s++;
  for( ; (*s == ' ') || (*s == '\t'); s++ );
  return s;
}
