/************************************************************************
 * Palm lab,
 * Department of Computer Science,
 * Sun Yat-sen University, Guangzhou, China
 * http://www.zsusoft.com/~hankz
 *
 * Copyright 2013, Hankz Hankui Zhuo and Lintao Chen
 *
 *
 * This file is part of HTNML.
 *
 * HTNML is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * HTNML is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HTNML.  If not, see <http://www.gnu.org/licenses/>.
 *
 ************************************************************************/


#ifndef _LEARNER_
#define _LEARNER_

#include "Tool.h"

#define RAND_NUM 100

extern float partObsPercent;

extern float partDtrPercent;

extern int cutPoint;

void buildObjectList(VariableList *list, char *type);

void buildVariableList(VariableList *list, char *var);

void buildTaskVariableList(VariableList *list, char *var);

void buildFormalPredList(VariableList *varList);

void buildPredList(PredicateList **list, VariableList *varList);

void buildActualPredList(VariableList *varList);

void buildVariableTable(VariableTable *table, VariableList *list);

void buildDtrList(Task *task);

void buildActionSchemaList(VariableList *varList);

void addTopLeaf(VariableTable *table, VariableList *list);

MethodStruct* addMethodStruct(VariableList *list, VariableTable *table);

VariableTable* getVariableTable(NodeList *list);

Task* getPartTask(NodeList *nodeList);

Predicate* getActualPredicate(VariableList *list);

VariableList* getMethodParas(VariableList *varList, NodeList *nodeList);

void buildNodeList(NodeList *list, Node *node);

Action* getPartAction(VariableTable *table, VariableList *list);

void buildGoal(VariableTable *table);

Predicate* getPredicate(char *name, VariableList *list);

bool isStatePositive(char *var);

VariableTable *getPartObservations(VariableTable *table);

bool isComplete();

void addTopLeaf(NodeList *list);

void addTopTask(NodeList *list);

void addTopTask(Task *task);

void buildMethodStruct(Task *task, MethodStruct *methodStruct);

#endif
